<template>
  <v-row>
    <v-col cols="12">
      <v-data-table
        dense
        item-key="lot"
        class="reduced order-table"
        :headers="filteredHeaders"
        :items="products"
        :footer-props="footerProps"
        @current-items="setCurrentRows"
      >
        <template v-slot:body.prepend="{ isMobile }">
          <tr>
            <td :class="isMobile ? 'v-data-table__mobile-row' : ''">
              <v-combobox
                dense
                hide-details
                clearable
                multiple
                color="secondary"
                v-model.trim="filterPriceGroup"
                label="Гр.пр"
                item-text="text"
                item-value="value"
                :items="priceGroups"
              ></v-combobox>
            </td>
            <td :class="isMobile ? 'v-data-table__mobile-row' : ''">
              <v-text-field
                dense
                hide-details
                clearable
                height="25"
                color="secondary"
                v-model="filterName"
                label="Наименование"
                ref="filterName"
                @click="clearFilterName"
                @click:clear="clearFilterName"
              ></v-text-field>
            </td>
            <td :class="isMobile ? 'v-data-table__mobile-row' : ''">
              <v-text-field
                dense
                hide-details
                clearable
                height="25"
                color="secondary"
                v-model="filterManufacturer"
                label="Производитель"
              ></v-text-field>
            </td>
          </tr>
        </template>

        <template v-slot:item="{ item }">
          <tr
            :class="
              currentRow && currentRow != null && item.lot == currentRow.lot
                ? 'active'
                : ''
            "
          >
            <td class="text-center">{{ item.priceGroup }}</td>
            <td>
              <span
                class="body-1 font-weight-medium"
                :class="getNameColor(item)"
              >
                {{ item.name }}
                <span v-if="item.isEnrollPrice">*</span>
              </span>
              <v-avatar size="30" color="secondary" v-if="item.isPrescription">
                <v-icon dark>{{ icons.prescription }}</v-icon>
              </v-avatar>
              <v-avatar size="30" color="light-blue" v-if="item.isColdZone">
                <v-icon dark>{{ icons.temperatureCelsius }}</v-icon>
              </v-avatar>
              <v-chip
                dark
                color="secondary"
                v-if="getState(point.pointId, item.productId).length > 0"
              >
                {{ getState(point.pointId, item.productId)[0].state }}
                <v-avatar right class="accent">
                  {{ getState(point.pointId, item.productId)[0].quantity }}
                </v-avatar>
              </v-chip>
            </td>
            <td>{{ item.manufacturer }}</td>
            <td class="text-right orange lighten-5">
              <v-edit-dialog :return-value="item.orderQuantity" lazy>
                <v-layout justify-end>{{
                  Object.keys(selectedOrderItems).length > 0 &&
                  selectedOrderItems[item.lot + "." + point.pointId] != null
                    ? selectedOrderItems[item.lot + "." + point.pointId]
                        .quantity
                    : ""
                }}</v-layout>
                <template v-slot:input>
                  <v-text-field
                    label="Количество"
                    single-line
                    autofocus
                    clearable
                    type="number"
                    min="0"
                    :value="
                      Object.keys(selectedOrderItems).length > 0 &&
                      selectedOrderItems[item.lot + '.' + point.pointId] != null
                        ? selectedOrderItems[item.lot + '.' + point.pointId]
                            .quantity
                        : ''
                    "
                    @change="(value) => changeOrderQuantity(item, value)"
                  ></v-text-field>
                </template>
              </v-edit-dialog>
            </td>
            <td class="text-center">
              <span v-if="isLowExpiration(item.expiration)">
                <v-chip dark color="red">
                  {{ item.expiration | expiration }}
                </v-chip>
              </span>
              <span v-else>{{ item.expiration | expiration }}</span>
            </td>
            <td class="text-right">{{ item.price }}</td>
            <td class="text-right">{{ item.pack }}</td>
            <td class="text-right" v-if="item.quantity > 0">
              {{ item.quantity }}
            </td>
          </tr>
        </template>

        <template v-slot:no-results>
          <v-alert color="error" :icon="icons.alert" :value="true"
            >Не найден результат для "{{ filterName }}"</v-alert
          >
        </template>

        <template v-slot:no-data>
          <v-alert :value="true" type="warning">Записи не найдены</v-alert>
        </template>
      </v-data-table>
    </v-col>
  </v-row>
</template>

<script>
import { mapState, mapActions } from "vuex";

import { Icon } from "@/helpers";

export default {
  props: {
    products: Array,
    point: Object,
    productsStates: Array,
  },
  components: {},
  computed: {
    ...mapState({
      selectedOrderItems: (state) => state.orders.selectedOrderItems,
    }),
    headers: function () {
      return [
        {
          text: "Гр.прайса",
          value: "priceGroup",
          width: "3%",
          align: "center",
          filter: (value) => {
            if (
              !this.filterPriceGroup ||
              this.filterPriceGroup == null ||
              this.filterPriceGroup.length == 0
            )
              return true;

            return this.filterPriceGroup.some((item) => {
              return item.value == value;
            });
          },
        },
        {
          text: "Наименование",
          value: "name",
          filter: (value) => {
            if (!this.filterName) return true;

            return (
              value.search(new RegExp("(^|\\s)" + this.filterName, "i")) > -1
            );
          },
        },
        {
          text: "Производитель",
          value: "manufacturer",
          filter: (value) => {
            if (!this.filterManufacturer) return true;

            return value.search(new RegExp(this.filterManufacturer, "i")) > -1;
          },
        },
        {
          text: "Заказ",
          value: "orderQuantity",
          align: "right",
        },
        {
          text: "Срок годности",
          value: "expiration",
          align: "center",
          filter: (value) => {
            if (!this.filterStartExpiration && !this.filterEndExpiration)
              return true;

            if (this.filterStartExpiration && this.filterEndExpiration)
              return this.$dayjs(value).isBetween(
                this.filterStartExpiration,
                this.filterEndExpiration
              );

            if (this.filterStartExpiration) {
              return this.$dayjs(value).isSameOrAfter(
                this.filterStartExpiration,
                "day"
              );
            }

            if (this.filterEndExpiration)
              return this.$dayjs(value).isSameOrBefore(
                this.filterEndExpiration,
                "day"
              );
          },
        },
        {
          text: "Цена",
          value: "price",
          align: "right",
        },
        {
          text: "Упаковка",
          value: "pack",
          align: "right",
        },
        {
          text: "Остаток",
          value: "quantity",
          align: "right",
        },
      ];
    },
    priceGroups: function () {
      let result = Array.from(
        [...new Set(this.products.map((x) => x.priceGroup))]
          .filter(function (value) {
            return Number.isInteger(value);
          })
          .sort(),
        (x) => new Object({ text: x, value: x })
      );

      result.push({ text: "б/г", value: null });

      return result;
    },
    filteredHeaders: function () {
      if (this.products.every((p) => p.quantity === 0))
        return this.headers.filter((x) => x.value !== "quantity");
      else return this.headers;
    },
    footerProps: function () {
      return this.filterName && this.filterName.length > 2
        ? { itemsPerPageOptions: [-1] }
        : {
            itemsPerPageOptions: [100, 300, 500, 700, 1000],
          };
    },
  },
  methods: {
    ...mapActions({
      updateSelectedOrderItems: "orders/UPDATE_SELECTED_ORDER_ITEMS",
      upsertBasket: "baskets/UPSERT_BASKET",
    }),
    getNameColor: function (item) {
      if (item.isExpectedArrival) return "accent--text";

      if (item.isPromo) return "light-blue--text text--accent-3";
    },
    isLowExpiration: function (expiration) {
      if (
        this.$dayjs(expiration).isSameOrBefore(
          this.$dayjs().add(1, "year"),
          "month"
        )
      )
        return true;
    },
    setCurrentRows: function (value) {
      this.currentRows = value;
      this.currentRowIndex = -1;
    },
    clearFilterName: function () {
      this.filterName = "";
    },
    getState: function (pointId, productId) {
      return this.productsStates.filter(
        (item) =>
          item.pointId === pointId &&
          item.productId === productId &&
          item.state !== "" &&
          item.state.toLowerCase() !== "доставлен" &&
          item.state.toLowerCase() !== "отменен"
      );
    },
    changeOrderQuantity: function (product, quantity) {
      if (quantity == null || quantity == "") quantity = 0;

      if (
        product &&
        product != null &&
        Object.entries(product).length !== 0 &&
        product.constructor === Object &&
        this.point &&
        this.point != null &&
        Object.entries(this.point).length !== 0 &&
        this.point.constructor === Object
      ) {
        this.updateSelectedOrderItems({
          productId: product.productId,
          pointId: this.point.pointId,
          productName: product.name,
          manufacturer: product.manufacturer,
          productCountry: product.country,
          pointAddress: this.point.address,
          lot: product.lot,
          expiration: product.expiration,
          price: product.price,
          quantity,
        });

        this.upsertBasket({
          pointId: this.point.pointId,
          productId: product.productId,
          lot: product.lot,
          expiration: product.expiration,
          price: product.price,
          quantity,
        });
      }
    },
    keydownEventListener: function (e) {
      if (e && e != null) {
        if (e.code == "F7") {
          this.clearFilterName();
          this.currentRowQuantity = "";
          if (this.$refs && this.$refs.filterName) {
            this.$vuetify.goTo(".vue-sticky-placeholder");
            this.$refs.filterName.focus();
          }
        }

        if (e.target.nodeName.toLowerCase() == "input") {
          if (e.code == "Enter" || e.code == "NumpadEnter") {
            switch (e.target.type.toLowerCase()) {
              case "text":
                if (this.$refs && this.$refs.filterName)
                  this.$refs.filterName.blur();
                break;
            }
          }
        }

        if (e.target.nodeName.toLowerCase() == "body") {
          if (
            e.code == "ArrowUp" &&
            this.currentRows &&
            this.currentRowIndex > -1
          ) {
            this.currentRowQuantity = "";
            this.currentRowIndex--;
            this.currentRow = this.currentRows[this.currentRowIndex];
          }

          if (
            e.code == "ArrowDown" &&
            this.currentRows &&
            this.currentRowIndex < this.currentRows.length
          ) {
            this.currentRowQuantity = "";
            this.currentRowIndex++;
            this.currentRow = this.currentRows[this.currentRowIndex];
          }

          if (e.code == "Backspace") {
            this.filterName = this.filterName.substring(
              0,
              this.filterName.length - 1
            );
          }

          if (
            e.code.startsWith("Key") ||
            e.code == "Semicolon" ||
            e.code == "Quote" ||
            e.code == "Backquote" ||
            e.code == "BracketLeft" ||
            e.code == "BracketRight" ||
            e.code == "Comma" ||
            e.code == "Period"
          ) {
            this.filterName += e.key;
          }

          if (
            e.code.startsWith("Digit") ||
            e.code == "Numpad0" ||
            e.code == "Numpad1" ||
            e.code == "Numpad2" ||
            e.code == "Numpad3" ||
            e.code == "Numpad4" ||
            e.code == "Numpad5" ||
            e.code == "Numpad6" ||
            e.code == "Numpad7" ||
            e.code == "Numpad8" ||
            e.code == "Numpad9"
          ) {
            this.currentRowQuantity += e.key;
            this.changeOrderQuantity(this.currentRow, this.currentRowQuantity);
          }
        }
      }
    },
  },
  data: () => ({
    currentRowIndex: -1,
    currentRows: [],
    currentRow: {},
    currentRowQuantity: "",
    filterName: "",
    filterManufacturer: "",
    filterPriceGroup: "",

    icons: {
      arrowLeftRight: Icon.arrowLeftRight,
      alert: Icon.alert,
      magnify: Icon.magnify,
      temperatureCelsius: Icon.temperatureCelsius,
      prescription: Icon.prescription,
    },
    countPoints: 0,
  }),
  mounted: function () {
    window.addEventListener("keydown", this.keydownEventListener);
  },
  beforeDestroy: function () {
    window.removeEventListener("keydown", this.keydownEventListener);
  },
};
</script>
